<?php

namespace AbonnementApiV6;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'applicationError' => '\\AbonnementApiV6\\StructType\\ApplicationError',
            'Abonnementsoort' => '\\AbonnementApiV6\\StructType\\Abonnementsoort',
            'Abonnement' => '\\AbonnementApiV6\\StructType\\Abonnement',
            'AboInfoRec' => '\\AbonnementApiV6\\StructType\\AboInfoRec',
            'AboObject' => '\\AbonnementApiV6\\StructType\\AboObject',
            'AboPakketAanvProd' => '\\AbonnementApiV6\\StructType\\AboPakketAanvProd',
            'AboPakketAboSoort' => '\\AbonnementApiV6\\StructType\\AboPakketAboSoort',
            'AboPakket' => '\\AbonnementApiV6\\StructType\\AboPakket',
            'AboRelatie' => '\\AbonnementApiV6\\StructType\\AboRelatie',
            'Actie' => '\\AbonnementApiV6\\StructType\\Actie',
            'AdresObject' => '\\AbonnementApiV6\\StructType\\AdresObject',
            'Calamiteit' => '\\AbonnementApiV6\\StructType\\Calamiteit',
            'Creditcard' => '\\AbonnementApiV6\\StructType\\Creditcard',
            'Editie' => '\\AbonnementApiV6\\StructType\\Editie',
            'FactuurAdres' => '\\AbonnementApiV6\\StructType\\FactuurAdres',
            'FactSamenvatBtw' => '\\AbonnementApiV6\\StructType\\FactSamenvatBtw',
            'FactSamenvatSubtot' => '\\AbonnementApiV6\\StructType\\FactSamenvatSubtot',
            'FactSamenvat' => '\\AbonnementApiV6\\StructType\\FactSamenvat',
            'Herkomst' => '\\AbonnementApiV6\\StructType\\Herkomst',
            'Klacht' => '\\AbonnementApiV6\\StructType\\Klacht',
            'Licentiehouder' => '\\AbonnementApiV6\\StructType\\Licentiehouder',
            'PersoonsObject' => '\\AbonnementApiV6\\StructType\\PersoonsObject',
            'Proposities' => '\\AbonnementApiV6\\StructType\\Proposities',
            'PropositieObject' => '\\AbonnementApiV6\\StructType\\PropositieObject',
            'PropositiePremiums' => '\\AbonnementApiV6\\StructType\\PropositiePremiums',
            'Rol' => '\\AbonnementApiV6\\StructType\\Rol',
            'SearchAbonnementResult' => '\\AbonnementApiV6\\StructType\\SearchAbonnementResult',
            'ToekMut' => '\\AbonnementApiV6\\StructType\\ToekMut',
            'UitgaveObject' => '\\AbonnementApiV6\\StructType\\UitgaveObject',
            'Uitgave' => '\\AbonnementApiV6\\StructType\\Uitgave',
            'VerschInfo' => '\\AbonnementApiV6\\StructType\\VerschInfo',
            'VrijeVeldenAboRec' => '\\AbonnementApiV6\\StructType\\VrijeVeldenAboRec',
            'VrijCodeveldAboRec' => '\\AbonnementApiV6\\StructType\\VrijCodeveldAboRec',
            'VrijDatumveldAboRec' => '\\AbonnementApiV6\\StructType\\VrijDatumveldAboRec',
            'VrijTekstveldAboRec' => '\\AbonnementApiV6\\StructType\\VrijTekstveldAboRec',
            'VrijVeldCode' => '\\AbonnementApiV6\\StructType\\VrijVeldCode',
            'VrijVeldDatum' => '\\AbonnementApiV6\\StructType\\VrijVeldDatum',
            'VrijVeldTekst' => '\\AbonnementApiV6\\StructType\\VrijVeldTekst',
            'WebserviceOperatie' => '\\AbonnementApiV6\\StructType\\WebserviceOperatie',
            'AbonnementsoortInfo' => '\\AbonnementApiV6\\StructType\\AbonnementsoortInfo',
            'AbonnementInfo' => '\\AbonnementApiV6\\StructType\\AbonnementInfo',
            'AbonnementTab' => '\\AbonnementApiV6\\StructType\\AbonnementTab',
            'AboInfoTab' => '\\AbonnementApiV6\\StructType\\AboInfoTab',
            'AboPakketAanvProdInfo' => '\\AbonnementApiV6\\StructType\\AboPakketAanvProdInfo',
            'AboPakketAboSoortInfo' => '\\AbonnementApiV6\\StructType\\AboPakketAboSoortInfo',
            'AboPakketInfo' => '\\AbonnementApiV6\\StructType\\AboPakketInfo',
            'ActieInfo' => '\\AbonnementApiV6\\StructType\\ActieInfo',
            'CalamiteitTab' => '\\AbonnementApiV6\\StructType\\CalamiteitTab',
            'EditieInfo' => '\\AbonnementApiV6\\StructType\\EditieInfo',
            'FactSamenvatBtwInfo' => '\\AbonnementApiV6\\StructType\\FactSamenvatBtwInfo',
            'FactSamenvatInfo' => '\\AbonnementApiV6\\StructType\\FactSamenvatInfo',
            'FactSamenvatSubtotInfo' => '\\AbonnementApiV6\\StructType\\FactSamenvatSubtotInfo',
            'HerkomstInfo' => '\\AbonnementApiV6\\StructType\\HerkomstInfo',
            'KlachtTab' => '\\AbonnementApiV6\\StructType\\KlachtTab',
            'LeverbareProductenInfo' => '\\AbonnementApiV6\\StructType\\LeverbareProductenInfo',
            'LicentiehouderInfo' => '\\AbonnementApiV6\\StructType\\LicentiehouderInfo',
            'PropositieInfo' => '\\AbonnementApiV6\\StructType\\PropositieInfo',
            'PropositiePremiumsTab' => '\\AbonnementApiV6\\StructType\\PropositiePremiumsTab',
            'PropositieTab' => '\\AbonnementApiV6\\StructType\\PropositieTab',
            'RolInfo' => '\\AbonnementApiV6\\StructType\\RolInfo',
            'ToekMutInfo' => '\\AbonnementApiV6\\StructType\\ToekMutInfo',
            'UitgaveInfo' => '\\AbonnementApiV6\\StructType\\UitgaveInfo',
            'VerschInfoTab' => '\\AbonnementApiV6\\StructType\\VerschInfoTab',
            'WebserviceOperaties' => '\\AbonnementApiV6\\StructType\\WebserviceOperaties',
            'testConnectionRequest' => '\\AbonnementApiV6\\StructType\\TestConnectionRequest',
            'testConnectionResponse' => '\\AbonnementApiV6\\StructType\\TestConnectionResponse',
            'getUitgaveInfoRequest' => '\\AbonnementApiV6\\StructType\\GetUitgaveInfoRequest',
            'getUitgaveInfoResponse' => '\\AbonnementApiV6\\StructType\\GetUitgaveInfoResponse',
            'getAbonnementsoortInfoRequest' => '\\AbonnementApiV6\\StructType\\GetAbonnementsoortInfoRequest',
            'getAbonnementsoortInfoResponse' => '\\AbonnementApiV6\\StructType\\GetAbonnementsoortInfoResponse',
            'getPakketInfoRequest' => '\\AbonnementApiV6\\StructType\\GetPakketInfoRequest',
            'getPakketInfoResponse' => '\\AbonnementApiV6\\StructType\\GetPakketInfoResponse',
            'getActieInfoRequest' => '\\AbonnementApiV6\\StructType\\GetActieInfoRequest',
            'getActieInfoResponse' => '\\AbonnementApiV6\\StructType\\GetActieInfoResponse',
            'getPropositieInfoRequest' => '\\AbonnementApiV6\\StructType\\GetPropositieInfoRequest',
            'getPropositieInfoResponse' => '\\AbonnementApiV6\\StructType\\GetPropositieInfoResponse',
            'getAbonnementInfoRequest' => '\\AbonnementApiV6\\StructType\\GetAbonnementInfoRequest',
            'getAbonnementInfoResponse' => '\\AbonnementApiV6\\StructType\\GetAbonnementInfoResponse',
            'searchAbonnementRequest' => '\\AbonnementApiV6\\StructType\\SearchAbonnementRequest',
            'searchAbonnementResponse' => '\\AbonnementApiV6\\StructType\\SearchAbonnementResponse',
            'searchAbonnementByCredRequest' => '\\AbonnementApiV6\\StructType\\SearchAbonnementByCredRequest',
            'searchAbonnementByCredResponse' => '\\AbonnementApiV6\\StructType\\SearchAbonnementByCredResponse',
            'searchSmartcodeRequest' => '\\AbonnementApiV6\\StructType\\SearchSmartcodeRequest',
            'searchSmartcodeResponse' => '\\AbonnementApiV6\\StructType\\SearchSmartcodeResponse',
            'getSmartcodeByAboNoRequest' => '\\AbonnementApiV6\\StructType\\GetSmartcodeByAboNoRequest',
            'getSmartcodeByAboNoResponse' => '\\AbonnementApiV6\\StructType\\GetSmartcodeByAboNoResponse',
            'getRelatieAbosoortPrijsRequest' => '\\AbonnementApiV6\\StructType\\GetRelatieAbosoortPrijsRequest',
            'getRelatieAbosoortPrijsResponse' => '\\AbonnementApiV6\\StructType\\GetRelatieAbosoortPrijsResponse',
            'checkProefaboRequest' => '\\AbonnementApiV6\\StructType\\CheckProefaboRequest',
            'checkProefaboResponse' => '\\AbonnementApiV6\\StructType\\CheckProefaboResponse',
            'checkActieaboRequest' => '\\AbonnementApiV6\\StructType\\CheckActieaboRequest',
            'checkActieaboResponse' => '\\AbonnementApiV6\\StructType\\CheckActieaboResponse',
            'createAboAboNawRequest' => '\\AbonnementApiV6\\StructType\\CreateAboAboNawRequest',
            'createAboAboNawResponse' => '\\AbonnementApiV6\\StructType\\CreateAboAboNawResponse',
            'createAboAboNoRequest' => '\\AbonnementApiV6\\StructType\\CreateAboAboNoRequest',
            'createAboAboNoResponse' => '\\AbonnementApiV6\\StructType\\CreateAboAboNoResponse',
            'createAboDebNawAboNawRequest' => '\\AbonnementApiV6\\StructType\\CreateAboDebNawAboNawRequest',
            'createAboDebNawAboNawResponse' => '\\AbonnementApiV6\\StructType\\CreateAboDebNawAboNawResponse',
            'createAboDebNawAboNoRequest' => '\\AbonnementApiV6\\StructType\\CreateAboDebNawAboNoRequest',
            'createAboDebNawAboNoResponse' => '\\AbonnementApiV6\\StructType\\CreateAboDebNawAboNoResponse',
            'createAboDebNoAboNawRequest' => '\\AbonnementApiV6\\StructType\\CreateAboDebNoAboNawRequest',
            'createAboDebNoAboNawResponse' => '\\AbonnementApiV6\\StructType\\CreateAboDebNoAboNawResponse',
            'createAboDebNoAboNoRequest' => '\\AbonnementApiV6\\StructType\\CreateAboDebNoAboNoRequest',
            'createAboDebNoAboNoResponse' => '\\AbonnementApiV6\\StructType\\CreateAboDebNoAboNoResponse',
            'createVervolgAbonnementRequest' => '\\AbonnementApiV6\\StructType\\CreateVervolgAbonnementRequest',
            'createVervolgAbonnementResponse' => '\\AbonnementApiV6\\StructType\\CreateVervolgAbonnementResponse',
            'updateAboBetaalwijzeRequest' => '\\AbonnementApiV6\\StructType\\UpdateAboBetaalwijzeRequest',
            'updateAboBetaalwijzeResponse' => '\\AbonnementApiV6\\StructType\\UpdateAboBetaalwijzeResponse',
            'updateAboPasswordRequest' => '\\AbonnementApiV6\\StructType\\UpdateAboPasswordRequest',
            'updateAboPasswordResponse' => '\\AbonnementApiV6\\StructType\\UpdateAboPasswordResponse',
            'updateLicentieRequest' => '\\AbonnementApiV6\\StructType\\UpdateLicentieRequest',
            'updateLicentieResponse' => '\\AbonnementApiV6\\StructType\\UpdateLicentieResponse',
            'createVakantieRegelingRequest' => '\\AbonnementApiV6\\StructType\\CreateVakantieRegelingRequest',
            'createVakantieRegelingResponse' => '\\AbonnementApiV6\\StructType\\CreateVakantieRegelingResponse',
            'createVerhuizingRequest' => '\\AbonnementApiV6\\StructType\\CreateVerhuizingRequest',
            'createVerhuizingResponse' => '\\AbonnementApiV6\\StructType\\CreateVerhuizingResponse',
            'createBezorgKlachtRequest' => '\\AbonnementApiV6\\StructType\\CreateBezorgKlachtRequest',
            'createBezorgKlachtResponse' => '\\AbonnementApiV6\\StructType\\CreateBezorgKlachtResponse',
            'createBezKlachtRelUitgaveRequest' => '\\AbonnementApiV6\\StructType\\CreateBezKlachtRelUitgaveRequest',
            'createBezKlachtRelUitgaveResponse' => '\\AbonnementApiV6\\StructType\\CreateBezKlachtRelUitgaveResponse',
            'getCalamiteitInfoRequest' => '\\AbonnementApiV6\\StructType\\GetCalamiteitInfoRequest',
            'getCalamiteitInfoResponse' => '\\AbonnementApiV6\\StructType\\GetCalamiteitInfoResponse',
            'getCalamiteitInfoByPcHnrRequest' => '\\AbonnementApiV6\\StructType\\GetCalamiteitInfoByPcHnrRequest',
            'getCalamiteitInfoByPcHnrResponse' => '\\AbonnementApiV6\\StructType\\GetCalamiteitInfoByPcHnrResponse',
            'getHerkomstInfoRequest' => '\\AbonnementApiV6\\StructType\\GetHerkomstInfoRequest',
            'getHerkomstInfoResponse' => '\\AbonnementApiV6\\StructType\\GetHerkomstInfoResponse',
            'searchRelNoByAboNoRequest' => '\\AbonnementApiV6\\StructType\\SearchRelNoByAboNoRequest',
            'searchRelNoByAboNoResponse' => '\\AbonnementApiV6\\StructType\\SearchRelNoByAboNoResponse',
            'createKlantPersoonRequest' => '\\AbonnementApiV6\\StructType\\CreateKlantPersoonRequest',
            'createKlantPersoonResponse' => '\\AbonnementApiV6\\StructType\\CreateKlantPersoonResponse',
            'updateKlantPersoonRequest' => '\\AbonnementApiV6\\StructType\\UpdateKlantPersoonRequest',
            'updateKlantPersoonResponse' => '\\AbonnementApiV6\\StructType\\UpdateKlantPersoonResponse',
            'updateKlantAdresRequest' => '\\AbonnementApiV6\\StructType\\UpdateKlantAdresRequest',
            'updateKlantAdresResponse' => '\\AbonnementApiV6\\StructType\\UpdateKlantAdresResponse',
            'getSwitchPropositiesRequest' => '\\AbonnementApiV6\\StructType\\GetSwitchPropositiesRequest',
            'getSwitchPropositiesResponse' => '\\AbonnementApiV6\\StructType\\GetSwitchPropositiesResponse',
            'switchAbonnementRequest' => '\\AbonnementApiV6\\StructType\\SwitchAbonnementRequest',
            'switchAbonnementResponse' => '\\AbonnementApiV6\\StructType\\SwitchAbonnementResponse',
            'getLeverbareProductenInfoRequest' => '\\AbonnementApiV6\\StructType\\GetLeverbareProductenInfoRequest',
            'getLeverbareProductenInfoResponse' => '\\AbonnementApiV6\\StructType\\GetLeverbareProductenInfoResponse',
            'wijkCheckRequest' => '\\AbonnementApiV6\\StructType\\WijkCheckRequest',
            'wijkCheckResponse' => '\\AbonnementApiV6\\StructType\\WijkCheckResponse',
            'getRolInfoRequest' => '\\AbonnementApiV6\\StructType\\GetRolInfoRequest',
            'getRolInfoResponse' => '\\AbonnementApiV6\\StructType\\GetRolInfoResponse',
            'addLicentiehouderRolRequest' => '\\AbonnementApiV6\\StructType\\AddLicentiehouderRolRequest',
            'addLicentiehouderRolResponse' => '\\AbonnementApiV6\\StructType\\AddLicentiehouderRolResponse',
            'updateLicentiehouderRolRequest' => '\\AbonnementApiV6\\StructType\\UpdateLicentiehouderRolRequest',
            'updateLicentiehouderRolResponse' => '\\AbonnementApiV6\\StructType\\UpdateLicentiehouderRolResponse',
            'deleteLicentiehouderRolRequest' => '\\AbonnementApiV6\\StructType\\DeleteLicentiehouderRolRequest',
            'deleteLicentiehouderRolResponse' => '\\AbonnementApiV6\\StructType\\DeleteLicentiehouderRolResponse',
            'getLicentiehoudersRequest' => '\\AbonnementApiV6\\StructType\\GetLicentiehoudersRequest',
            'getLicentiehoudersResponse' => '\\AbonnementApiV6\\StructType\\GetLicentiehoudersResponse',
            'addLicentiehouderRequest' => '\\AbonnementApiV6\\StructType\\AddLicentiehouderRequest',
            'addLicentiehouderResponse' => '\\AbonnementApiV6\\StructType\\AddLicentiehouderResponse',
            'deleteLicentiehouderRequest' => '\\AbonnementApiV6\\StructType\\DeleteLicentiehouderRequest',
            'deleteLicentiehouderResponse' => '\\AbonnementApiV6\\StructType\\DeleteLicentiehouderResponse',
            'stopGratisAboPerDirectRequest' => '\\AbonnementApiV6\\StructType\\StopGratisAboPerDirectRequest',
            'stopGratisAboPerDirectResponse' => '\\AbonnementApiV6\\StructType\\StopGratisAboPerDirectResponse',
            'getFactSamenvatInfoRequest' => '\\AbonnementApiV6\\StructType\\GetFactSamenvatInfoRequest',
            'getFactSamenvatInfoResponse' => '\\AbonnementApiV6\\StructType\\GetFactSamenvatInfoResponse',
            'getToekomstigeMutatiesRequest' => '\\AbonnementApiV6\\StructType\\GetToekomstigeMutatiesRequest',
            'getToekomstigeMutatiesResponse' => '\\AbonnementApiV6\\StructType\\GetToekomstigeMutatiesResponse',
            'deleteToekomstigeMutatieRequest' => '\\AbonnementApiV6\\StructType\\DeleteToekomstigeMutatieRequest',
            'deleteToekomstigeMutatieResponse' => '\\AbonnementApiV6\\StructType\\DeleteToekomstigeMutatieResponse',
            'cancelBezorgKlachtRequest' => '\\AbonnementApiV6\\StructType\\CancelBezorgKlachtRequest',
            'cancelBezorgKlachtResponse' => '\\AbonnementApiV6\\StructType\\CancelBezorgKlachtResponse',
            'getEditiesRequest' => '\\AbonnementApiV6\\StructType\\GetEditiesRequest',
            'getEditiesResponse' => '\\AbonnementApiV6\\StructType\\GetEditiesResponse',
            'getEersteVerschijningRequest' => '\\AbonnementApiV6\\StructType\\GetEersteVerschijningRequest',
            'getEersteVerschijningResponse' => '\\AbonnementApiV6\\StructType\\GetEersteVerschijningResponse',
            'bestaatActiefAbonnementRequest' => '\\AbonnementApiV6\\StructType\\BestaatActiefAbonnementRequest',
            'bestaatActiefAbonnementResponse' => '\\AbonnementApiV6\\StructType\\BestaatActiefAbonnementResponse',
            'renewAbonnementRequest' => '\\AbonnementApiV6\\StructType\\RenewAbonnementRequest',
            'renewAbonnementResponse' => '\\AbonnementApiV6\\StructType\\RenewAbonnementResponse',
        );
    }
}
