<?php

namespace AbonnementApiV6\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @subpackage Services
 * @date 20240419 package
 */
class Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named createAboAboNaw
     * Meta information extracted from the WSDL
     * - documentation: <u><b>Deprecated waarschuwing:</b> Deze operatie zal in een toekomstige webservice versie V6 worden verwijderd. <br/> Als alternatief wordt aangeraden om <b>createAboAboNo</b> te gebruiken i.c.m. de RelatieApiV6 om de relatie aan te
     * maken. </br></u> <br/> Aanmaken van een nieuw abonnement voor een relatie, waarbij de NAW gegevens van de relatie meegegeven kan worden. Deze relatie wordt zowel als abonnee als debiteur aan het abonnement gekoppeld.error3: De betaalwijze is niet
     * bekenderror4: Bij automatische incasso is een rekeningnummer verplichterror16: De editie is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of
     * een pakketcode operror34: De actie is niet gevondenerror36: De herkomst is niet bekenderror39: Het land voor de abonnee is niet gevondenerror43: Voor de abonnee ontbreekt de achternaamerror44: Voor de abonnee ontbreken adresgegevenserror45: Het adres
     * van de abonnee is incompleeterror46: Het e-mail adres van de abonnee voldoet niet aan de eisenerror47: Het telefoonnummer van de abonnee is niet geldigerror56: De abonnementsoort is niet actieferror57: De actie is niet actieferror58: De premium voor
     * de abonnee is niet actieferror64: Het mobiele telefoonnummer voor de abonnee is niet geldigerror67: De provincie voor de abonnee is niet gevondenerror70: De provincie voor de abonnee is niet gekoppeld aan het landerror73: Voor de provincie voor de
     * abonnee is een land verplichterror75: Titulatuur voor de abonnee is niet gevondenerror82: Het adres voor de abonnee is niet gevonden in de postcodetabelerror84: Voor de abonnee is al een actief abonnement met dezelfde uitgave aanwezig (deze melding
     * kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het opgegeven pakket is niet bekenderror89: Het opgegeven pakket is niet actieferror91: De
     * premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror95: De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de
     * propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror105: Het opgegeven geslacht voor de abonnee is niet geldigerror107: Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De
     * abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror131: Een betaalwijze anders dan incasso is niet
     * toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te
     * wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror220: Het IBAN nummer van de abonnee is ongeldigerror221: De BIC code van de abonnee is ongeldigerror222: Bij de abonnee dient het IBAN nummer samen met de BIC code
     * opgegeven te wordenerror223: De bij de abonnee opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is niet actief en mag niet toegekend wordenerror242: Een losse
     * eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op basis van de opgegeven abosoort/pakket/propositiecode en
     * actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De opgegeven vrije code 1 is niet bekenderror262: De
     * opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror265: Een betaalwijze anders dan factuur per mail is niet toegestaan voor dit
     * abonnementerror268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror272: Bij het gekozen product is een abonnee met incomplete NAW gegevens niet
     * toegestaanerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige korting is al tot het maximum aantal keer
     * gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror280: De uitgave is niet leverbaar op dit adreserror281: De uitgave is binnenkort niet meer leverbaar op dit adreserror282: Het is niet mogelijk
     * een actieabonnement aan te makenerror601: LET OP: Deze fout krijgt voortaan een ander nummer 602: Er zijn meerdere kandidaten gevonden voor de abonneeerror602: Er zijn meerdere kandidaten gevonden voor de abonneeerror607: Er zijn afwijkende
     * kandidaten gevonden voor de abonneeerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboAboNawRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboAboNawResponse|bool
     */
    public function createAboAboNaw(\AbonnementApiV6\StructType\CreateAboAboNawRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboAboNaw($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createAboAboNo
     * Meta information extracted from the WSDL
     * - documentation: Aanmaken van een nieuw abonnement voor een relatie, waarbij het relatienummer van een bestaande relatie meegegeven kan worden.error3: De betaalwijze is niet bekenderror4: Bij automatische incasso is een rekeningnummer
     * verplichterror16: De editie is niet gevondenerror21: De debiteur is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of een pakketcode operror34:
     * De actie is niet gevondenerror36: De herkomst is niet bekenderror37: Er is geen debiteur opgegeven voor het abonnementerror56: De abonnementsoort is niet actieferror57: De actie is niet actieferror58: De premium voor de abonnee is niet actieferror84:
     * Voor de abonnee is al een actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het
     * opgegeven pakket is niet bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror93: De abonnee is niet gevondenerror94: Er is geen abonnee opgegevenerror95:
     * De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror107:
     * Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum heeft een verkeerd formaat of kan niet tot
     * een bestaande datum worden herleiderror131: Een betaalwijze anders dan incasso is niet toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een
     * IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is
     * niet actief en mag niet toegekend wordenerror242: Een losse eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op
     * basis van de opgegeven abosoort/pakket/propositiecode en actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De
     * opgegeven vrije code 1 is niet bekenderror262: De opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror265: Een betaalwijze anders
     * dan factuur per mail is niet toegestaan voor dit abonnementerror268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror272: Bij het gekozen product is een
     * abonnee met incomplete NAW gegevens niet toegestaanerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige
     * korting is al tot het maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror280: De uitgave is niet leverbaar op dit adreserror281: De uitgave is binnenkort niet meer leverbaar op
     * dit adreserror282: Het is niet mogelijk een actieabonnement aan te makenerror283: Het op te volgen abonnement is geen actieabonnementerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboAboNoRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboAboNoResponse|bool
     */
    public function createAboAboNo(\AbonnementApiV6\StructType\CreateAboAboNoRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboAboNo($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createAboDebNawAboNaw
     * Meta information extracted from the WSDL
     * - documentation: <u><b>Deprecated waarschuwing:</b> Deze operatie zal in een toekomstige webservice versie V6 worden verwijderd. <br/> Als alternatief wordt aangeraden om <b>createAboDebNoAboNo</b> te gebruiken i.c.m. de RelatieApiV6 om de relatie
     * aan te maken. </br></u> <br/> Aanmaken van een nieuw abonnement voor een relatie, waarbij zowel de NAW gegevens van de abonnee als de NAW gegevens van de debiteur meegegeven kan worden.error3: De betaalwijze is niet bekenderror4: Bij automatische
     * incasso is een rekeningnummer verplichterror16: De editie is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of een pakketcode operror34: De
     * actie is niet gevondenerror36: De herkomst is niet bekenderror39: Het land voor de abonnee is niet gevondenerror43: Voor de abonnee ontbreekt de achternaamerror44: Voor de abonnee ontbreken adresgegevenserror45: Het adres van de abonnee is
     * incompleeterror46: Het e-mail adres van de abonnee voldoet niet aan de eisenerror47: Het telefoonnummer van de abonnee is niet geldigerror48: Het land voor de debiteur is niet gevondenerror51: Voor de debiteur ontbreekt de achternaamerror52: Voor de
     * debiteur ontbreken adresgegevenserror53: Het adres van de debiteur is incompleeterror54: Het e-mail adres van de debiteur voldoet niet aan de eisenerror55: Het telefoonnummer van de debiteur is niet geldigerror56: De abonnementsoort is niet
     * actieferror57: De actie is niet actieferror58: De premium voor de abonnee is niet actieferror60: Er zijn meerdere kandidaten gevonden voor de abonneeerror61: Er zijn meerdere kandidaten gevonden voor de debiteurerror64: Het mobiele telefoonnummer
     * voor de abonnee is niet geldigerror65: Het mobiele telefoonnummer voor de debiteur is niet geldigerror67: De provincie voor de abonnee is niet gevondenerror68: De provincie voor de debiteur is niet gevondenerror70: De provincie voor de abonnee is
     * niet gekoppeld aan het landerror71: De provincie voor de debiteur is niet gekoppeld aan het landerror73: Voor de provincie voor de abonnee is een land verplichterror74: Voor de provincie voor de debiteur is een land verplichterror75: Titulatuur voor
     * de abonnee is niet gevondenerror76: Titulatuur voor de debiteur is niet gevondenerror82: Het adres voor de abonnee is niet gevonden in de postcodetabelerror83: Het adres voor de debiteur is niet gevonden in de postcodetabelerror84: Voor de abonnee is
     * al een actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het opgegeven pakket is
     * niet bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror95: De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is
     * verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror105: Het opgegeven geslacht voor de abonnee is niet geldigerror106: Het opgegeven geslacht
     * voor de debiteur is niet geldigerror107: Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum
     * heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror131: Een betaalwijze anders dan incasso is niet toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij
     * automatische incasso of eenmalige incasso is een IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror220: Het IBAN nummer van de
     * abonnee is ongeldigerror221: De BIC code van de abonnee is ongeldigerror222: Bij de abonnee dient het IBAN nummer samen met de BIC code opgegeven te wordenerror223: De bij de abonnee opgegeven BIC code hoort niet bij het opgegeven IBAN
     * nummererror224: Het IBAN nummer van de debiteur is ongeldigerror225: De BIC code van de debiteur is ongeldigerror226: Bij de debiteur dient het IBAN nummer samen met de BIC code opgegeven te wordenerror227: De bij de debiteur opgegeven BIC code hoort
     * niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is niet actief en mag niet toegekend wordenerror242: Een losse eenmalige korting mag niet in combinatie met een voorgedefinieerde
     * eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op basis van de opgegeven abosoort/pakket/propositiecode en actiecode zijn meerdere proposities gevondenerror259: De opgegeven
     * vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De opgegeven vrije code 1 is niet bekenderror262: De opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4
     * is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror265: Een betaalwijze anders dan factuur per mail is niet toegestaan voor dit abonnementerror268: Een kortingsbedrag of percentage mag niet negatief
     * zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror270: Bij ontbreken van NAW gegevens is een e-mail adres voor de abonnee verplichterror272: Bij het gekozen product is een abonnee met incomplete NAW
     * gegevens niet toegestaanerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige korting is al tot het
     * maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror280: De uitgave is niet leverbaar op dit adreserror281: De uitgave is binnenkort niet meer leverbaar op dit adreserror282:
     * Het is niet mogelijk een actieabonnement aan te makenerror283: Het op te volgen abonnement is geen actieabonnementerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboDebNawAboNawRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboDebNawAboNawResponse|bool
     */
    public function createAboDebNawAboNaw(\AbonnementApiV6\StructType\CreateAboDebNawAboNawRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboDebNawAboNaw($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createAboDebNawAboNo
     * Meta information extracted from the WSDL
     * - documentation: <u><b>Deprecated waarschuwing:</b> Deze operatie zal in een toekomstige webservice versie V6 worden verwijderd. <br/> Als alternatief wordt aangeraden om <b>createAboDebNoAboNo</b> te gebruiken i.c.m. de RelatieApiV6 om de relatie
     * aan te maken. </br></u> <br/> Aanmaken van een nieuw abonnement voor een relatie, waarbij het relatienummer van de abonnee en de NAW gegevens van de debiteur meegegeven kan worden.error3: De betaalwijze is niet bekenderror4: Bij automatische incasso
     * is een rekeningnummer verplichterror16: De editie is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of een pakketcode operror34: De actie is niet gevondenerror36: De herkomst is niet
     * bekenderror48: Het land voor de debiteur is niet gevondenerror51: Voor de debiteur ontbreekt de achternaamerror52: Voor de debiteur ontbreken adresgegevenserror53: Het adres van de debiteur is incompleeterror54: Het e-mail adres van de debiteur
     * voldoet niet aan de eisenerror55: Het telefoonnummer van de debiteur is niet geldigerror56: De abonnementsoort is niet actieferror57: De actie is niet actieferror58: De premium voor de abonnee is niet actieferror65: Het mobiele telefoonnummer voor de
     * debiteur is niet geldigerror68: De provincie voor de debiteur is niet gevondenerror71: De provincie voor de debiteur is niet gekoppeld aan het landerror74: Voor de provincie voor de debiteur is een land verplichterror76: Titulatuur voor de debiteur
     * is niet gevondenerror83: Het adres voor de debiteur is niet gevonden in de postcodetabelerror84: Voor de abonnee is al een actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven
     * is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het opgegeven pakket is niet bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is
     * niet bekenderror93: De abonnee is niet gevondenerror94: Er is geen abonnee opgegevenerror95: De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de
     * propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror106: Het opgegeven geslacht voor de debiteur is niet geldigerror107: Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De
     * abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror131: Een betaalwijze anders dan incasso is niet
     * toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te
     * wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror224: Het IBAN nummer van de debiteur is ongeldigerror225: De BIC code van de debiteur is ongeldigerror226: Bij de debiteur dient het IBAN nummer samen met de BIC code
     * opgegeven te wordenerror227: De bij de debiteur opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is niet actief en mag niet toegekend wordenerror242: Een losse
     * eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op basis van de opgegeven abosoort/pakket/propositiecode en
     * actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De opgegeven vrije code 1 is niet bekenderror262: De
     * opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror265: Een betaalwijze anders dan factuur per mail is niet toegestaan voor dit
     * abonnementerror268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden
     * geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige korting is al tot het maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de
     * abonnementsoorterror282: Het is niet mogelijk een actieabonnement aan te makenerror283: Het op te volgen abonnement is geen actieabonnementerror601: LET OP: Deze fout krijgt voortaan een ander nummer 603: Er zijn meerdere kandidaten gevonden voor de
     * debiteurerror603: Er zijn meerdere kandidaten gevonden voor de debiteurerror608: Er zijn afwijkende kandidaten gevonden voor de debiteurerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboDebNawAboNoRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboDebNawAboNoResponse|bool
     */
    public function createAboDebNawAboNo(\AbonnementApiV6\StructType\CreateAboDebNawAboNoRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboDebNawAboNo($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createAboDebNoAboNaw
     * Meta information extracted from the WSDL
     * - documentation: <u><b>Deprecated waarschuwing:</b> Deze operatie zal in een toekomstige webservice versie V6 worden verwijderd. <br/> Als alternatief wordt aangeraden om <b>createAboDebNoAboNo</b> te gebruiken i.c.m. de RelatieApiV6 om de relatie
     * aan te maken. </br></u> <br/> Aanmaken van een nieuw abonnement voor een relatie, waarbij de NAW gegevens van de abonnee en het relatienummer van de debiteur meegegeven kan worden.error3: De betaalwijze is niet bekenderror4: Bij automatische incasso
     * is een rekeningnummer verplichterror16: De editie is niet gevondenerror21: De debiteur is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of een
     * pakketcode operror34: De actie is niet gevondenerror36: De herkomst is niet bekenderror37: Er is geen debiteur opgegeven voor het abonnementerror39: Het land voor de abonnee is niet gevondenerror43: Voor de abonnee ontbreekt de achternaamerror44:
     * Voor de abonnee ontbreken adresgegevenserror45: Het adres van de abonnee is incompleeterror46: Het e-mail adres van de abonnee voldoet niet aan de eisenerror47: Het telefoonnummer van de abonnee is niet geldigerror56: De abonnementsoort is niet
     * actieferror57: De actie is niet actieferror58: De premium voor de abonnee is niet actieferror64: Het mobiele telefoonnummer voor de abonnee is niet geldigerror67: De provincie voor de abonnee is niet gevondenerror70: De provincie voor de abonnee is
     * niet gekoppeld aan het landerror73: Voor de provincie voor de abonnee is een land verplichterror75: Titulatuur voor de abonnee is niet gevondenerror82: Het adres voor de abonnee is niet gevonden in de postcodetabelerror84: Voor de abonnee is al een
     * actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het opgegeven pakket is niet
     * bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror95: De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is
     * verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror105: Het opgegeven geslacht voor de abonnee is niet geldigerror107: Het abonnement kan niet
     * aangemaakt worden. Voor de debiteur geldt een leververboderror127: De abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum
     * worden herleiderror131: Een betaalwijze anders dan incasso is niet toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een IBAN nummer
     * verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror220: Het IBAN nummer van de abonnee is ongeldigerror221: De BIC code van de abonnee is
     * ongeldigerror222: Bij de abonnee dient het IBAN nummer samen met de BIC code opgegeven te wordenerror223: De bij de abonnee opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De
     * eenmalige korting is niet actief en mag niet toegekend wordenerror242: Een losse eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is
     * niet actieferror258: Op basis van de opgegeven abosoort/pakket/propositiecode en actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode
     * opgegeven te wordenerror261: De opgegeven vrije code 1 is niet bekenderror262: De opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard
     * verplichterror265: Een betaalwijze anders dan factuur per mail is niet toegestaan voor dit abonnementerror268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage
     * bevattenerror270: Bij ontbreken van NAW gegevens is een e-mail adres voor de abonnee verplichterror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten
     * zijn geldigheidsperiodeerror278: De eenmalige korting is al tot het maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror282: Het is niet mogelijk een actieabonnement aan te
     * makenerror283: Het op te volgen abonnement is geen actieabonnementerror602: Er zijn meerdere kandidaten gevonden voor de abonneeerror607: Er zijn afwijkende kandidaten gevonden voor de abonneeerror701: Bij een abonnement is een herkomst
     * verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboDebNoAboNawRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboDebNoAboNawResponse|bool
     */
    public function createAboDebNoAboNaw(\AbonnementApiV6\StructType\CreateAboDebNoAboNawRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboDebNoAboNaw($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createAboDebNoAboNo
     * Meta information extracted from the WSDL
     * - documentation: Aanmaken van een nieuw abonnement voor een relatie, waarbij zowel het relatienummer van de abonnee als van de debiteur meegegeven kan worden.error3: De betaalwijze is niet bekenderror4: Bij automatische incasso is een rekeningnummer
     * verplichterror16: De editie is niet gevondenerror21: De debiteur is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer voldoet nieterror33: Geef of een abonnementsoort- of een pakketcode operror34:
     * De actie is niet gevondenerror36: De herkomst is niet bekenderror37: Er is geen debiteur opgegeven voor het abonnementerror56: De abonnementsoort is niet actieferror57: De actie is niet actieferror58: De premium voor de abonnee is niet actieferror84:
     * Voor de abonnee is al een actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85: Het is niet mogelijk een proefabonnement aan te makenerror88: Het
     * opgegeven pakket is niet bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror93: De abonnee is niet gevondenerror94: Er is geen abonnee opgegevenerror95:
     * De ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror107:
     * Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de actieerror129: Datum heeft een verkeerd formaat of kan niet tot
     * een bestaande datum worden herleiderror131: Een betaalwijze anders dan incasso is niet toegestaan voor dit abonnementerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een
     * IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is
     * niet actief en mag niet toegekend wordenerror242: Een losse eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op
     * basis van de opgegeven abosoort/pakket/propositiecode en actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De
     * opgegeven vrije code 1 is niet bekenderror262: De opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror265: Een betaalwijze anders
     * dan factuur per mail is niet toegestaan voor dit abonnementerror268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror272: Bij het gekozen product is een
     * abonnee met incomplete NAW gegevens niet toegestaanerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige
     * korting is al tot het maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror280: De uitgave is niet leverbaar op dit adreserror281: De uitgave is binnenkort niet meer leverbaar op
     * dit adreserror282: Het is niet mogelijk een actieabonnement aan te makenerror283: Het op te volgen abonnement is geen actieabonnementerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateAboDebNoAboNoRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateAboDebNoAboNoResponse|bool
     */
    public function createAboDebNoAboNo(\AbonnementApiV6\StructType\CreateAboDebNoAboNoRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createAboDebNoAboNo($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createVervolgAbonnement
     * Meta information extracted from the WSDL
     * - documentation: Maakt op basis van een bestaand (proef-) abonnement een vervolgabonnement aan.</p> <p>Met createVervolgAbonnement kan een bestaand (proef-) abonnement opgevolgd worden met een nieuw abonnement. Voor het nieuwe abonnement kan een
     * afwijkende debiteur opgegeven worden, dit kan handig zijn bij het opvolgen van cadeauabonnementen (die doorgaans door een andere debiteur betaald worden). Indien dit leeggelaten wordt, zal de abonnee zelf als debiteur genomen worden. </p>
     * <p>Betreffende het veld ingangsDatum in het aboObject: <br/>- Indien deze leeg is, of in het verleden ligt, of voor de stopdatum van het bestaande abonnement ligt, dan wordt het vervolgabonnement aangemaakt met een ingangsdatum die aansluit op het
     * bestaande abonnement. <br/>- Anders wordt de opgegeven ingangsdatum voor het vervolg abonnement gebruikt.error1: Het abonnement is niet gevondenerror3: De betaalwijze is niet bekenderror4: Bij automatische incasso is een rekeningnummer
     * verplichterror5: De relatie is niet gevondenerror12: Er is geen abonnement opgegevenerror19: Er is geen relatie opgegevenerror21: De debiteur is niet gevondenerror23: De premium voor de abonnee is niet gevondenerror26: Het opgegeven rekeningnummer
     * voldoet nieterror33: Geef of een abonnementsoort- of een pakketcode operror34: De actie is niet gevondenerror35: Het abonnement heeft geen stopeditieerror36: De herkomst is niet bekenderror56: De abonnementsoort is niet actieferror57: De actie is
     * niet actieferror58: De premium voor de abonnee is niet actieferror84: Voor de abonnee is al een actief abonnement met dezelfde uitgave aanwezig (deze melding kan dus niet optreden als geenControleLopendAbo als 1 meegegeven is in het request)error85:
     * Het is niet mogelijk een proefabonnement aan te makenerror88: Het opgegeven pakket is niet bekenderror89: Het opgegeven pakket is niet actieferror91: De premium voor de debiteur is niet actieferror92: De abonnementsoort is niet bekenderror95: De
     * ingangsdatum van de actie is nog niet ingegaanerror96: De einddatum van de actie is verstrekenerror97: De premium voor de abonnee is niet gekoppeld aan de propositieerror98: De premium voor de debiteur is niet gekoppeld aan de propositieerror99: Het
     * op te volgen abonnement is geen proefabonnementerror107: Het abonnement kan niet aangemaakt worden. Voor de debiteur geldt een leververboderror127: De abonnementsoort is niet gekoppeld aan de actieerror128: Het pakket is niet gekoppeld aan de
     * actieerror130: Het is niet gelukt om een vervolgabonnement aan te makenerror215: Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een IBAN nummer verplichterror218: Het IBAN nummer
     * dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code hoort niet bij het opgegeven IBAN nummererror240: De eenmalige korting is niet gevondenerror241: De eenmalige korting is niet actief en mag niet toegekend wordenerror242:
     * Een losse eenmalige korting mag niet in combinatie met een voorgedefinieerde eenmalige korting toegekend wordenerror256: De proposie is niet gevondenerror257: De propositie is niet actieferror258: Op basis van de opgegeven
     * abosoort/pakket/propositiecode en actiecode zijn meerdere proposities gevondenerror259: De opgegeven vrije code 3 is niet bekenderror260: Een propositiecode dient in combinatie met een actiecode opgegeven te wordenerror261: De opgegeven vrije code 1
     * is niet bekenderror262: De opgegeven vrije code 2 is niet bekenderror263: De opgegeven vrije code 4 is niet bekenderror264: Bij betaalwijze creditcard zijn gegevens van de creditcard verplichterror272: Bij het gekozen product is een abonnee met
     * incomplete NAW gegevens niet toegestaanerror273: Bij betaalwijze betaling via derden dient de debiteur voor betaling via derden geregistreerd te zijnerror277: De eenmalige korting valt buiten zijn geldigheidsperiodeerror278: De eenmalige korting is
     * al tot het maximum aantal keer gebruikterror279: De eenmalige korting kan niet gebruikt worden in combinatie met de abonnementsoorterror280: De uitgave is niet leverbaar op dit adreserror281: De uitgave is binnenkort niet meer leverbaar op dit
     * adreserror282: Het is niet mogelijk een actieabonnement aan te makenerror283: Het op te volgen abonnement is geen actieabonnementerror701: Bij een abonnement is een herkomst verplichterror702: Bij een abonnement is een actie verplicht
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateVervolgAbonnementRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateVervolgAbonnementResponse|bool
     */
    public function createVervolgAbonnement(\AbonnementApiV6\StructType\CreateVervolgAbonnementRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createVervolgAbonnement($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createVakantieRegeling
     * Meta information extracted from the WSDL
     * - documentation: Maakt een vakantieregeling aan voor een abonnement van het type type 'onderbreking met verlenging' ,'vakantiebonnen', 'goed doel' of 'doorsturen'error1: Het abonnement is niet gevondenerror2: Het land is niet gevondenerror6: Mutaties
     * moeten in de toekomst liggenerror12: Er is geen abonnement opgegevenerror28: Bij een relatie is een naam verplichterror30: De adresgegevens zijn niet compleeterror31: Het e-mail adres voldoet niet aan de eisenerror32: De adresgegevens
     * ontbrekenerror38: Het telefoonnummer is niet geldigerror59: Er zijn meerdere kandidaten gevondenerror62: De titulatuur is niet bekenderror63: Het mobiele telefoonnummer is niet geldigerror66: De provincie is niet gevondenerror69: De provincie is niet
     * gekoppeld aan het landerror72: Voor een provincie is een land verplichterror81: Het adres is niet gevonden in de postcodetabelerror86: De einddatum mag niet voor de ingangsdatum van de vakantieregeling liggenerror87: Het opgegeven regelingtype voor
     * de vakantieregeling is niet bekenderror88: De opgegeven geboortedatum is niet geldigerror104: Het opgegeven geslacht is niet geldigerror110: Onderbreking is niet toegestaan, het abonnement heeft een einddatumerror111: Bij een vakantieregeling is een
     * ingangsdatum verplichterror112: Bij een vakantieregeling is een einddatum verplichterror113: Ongeldige lengte voor de vakantieregeling opgegevenerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror189:
     * Regeling is niet toegestaan, de ingangsdatum ligt voor de startdatum van het abonnementerror190: Regeling is niet toegestaan, de einddatum ligt na de stopdatum van het abonnementerror265: Doorgifte van een tijdelijke afdelingsnaam alleen toegestaan
     * bij regeling type 4 (Vakantieadres)error268: Een kortingsbedrag of percentage mag niet negatief zijnerror269: Een abonnement mag maximaal 1 kortingsbedrag of kortingspercentage bevattenerror502: Vakantieregeling is niet toegestaan voor dit type
     * abonnementerror503: De onderbreking ligt te dicht bij een voorgaande of opvolgende onderbrekingerror504: Bij de abonnementsoort ontbreken instellingen om te bepalen of de vakantieregeling toegestaan iserror505: De instellingen bij de abonnementsoort
     * voor de vakantieregeling zijn ongeldigerror506: Levering in het buitenland niet toegestaan voor dit abonnementerror507: In de opgegeven periode staat al een vakantieregeling genoteerd
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateVakantieRegelingRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingResponse|bool
     */
    public function createVakantieRegeling(\AbonnementApiV6\StructType\CreateVakantieRegelingRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createVakantieRegeling($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createVerhuizing
     * Meta information extracted from the WSDL
     * - documentation: Maakt een verhuizing aan voor een bestaande relatieerror2: Het land is niet gevondenerror5: De relatie is niet gevondenerror6: Mutaties moeten in de toekomst liggenerror7: Adrestype is niet bekenderror19: Er is geen relatie
     * opgegevenerror30: De adresgegevens zijn niet compleeterror32: De adresgegevens ontbrekenerror66: De provincie is niet gevondenerror69: De provincie is niet gekoppeld aan het landerror72: Voor een provincie is een land verplichterror81: Het adres is
     * niet gevonden in de postcodetabelerror124: Bij een verhuizing is een ingangsdatum verplichterror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror280: De uitgave is niet leverbaar op dit adreserror281: De
     * uitgave is binnenkort niet meer leverbaar op dit adreserror401: Verhuizing is niet toegestaan voor dit abonnementerror402: Levering in het buitenland niet toegestaan voor dit abonnement
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateVerhuizingRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateVerhuizingResponse|bool
     */
    public function createVerhuizing(\AbonnementApiV6\StructType\CreateVerhuizingRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createVerhuizing($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createBezorgKlacht
     * Meta information extracted from the WSDL
     * - documentation: Aanmaken van een bezorgklacht op basis van een abonnementsnummererror1: Het abonnement is niet gevondenerror12: Er is geen abonnement opgegevenerror13: Er is geen klachtsoort opgegevenerror14: De klachtsoort is niet bekenderror15:
     * Het klachtonderwerp is niet bekenderror17: De default klachtstatus is niet gevondenerror18: Er is geen klachtsoort opgegevenerror25: Er is geen datum voor de klacht opgegevenerror77: Het klachtonderwerp is niet gekoppeld bij de klachtsoorterror78: Op
     * basis van de klachtdatum is geen editie gevondenerror79: De klachtsoort is niet actieferror80: Het klachtonderwerp is niet actieferror116: Deze klacht is niet aan een abonnement en niet aan een LVK-punt gekoppeld en kan daarom niet ingevoerd
     * wordenerror117: Uiterste bezorgtijd is nog niet verstreken. Klacht is niet geregistreerderror118: Het abonnement had op de opgegeven datum geen recht op een blad of was niet actieferror119: Het abonnement krijgt op de opgegeven datum bonnen en geen
     * bladerror120: Het abonnement werd op de opgegeven datum doorgestuurd naar een goed doel en ontving dus geen bladerror121: Het abonnement had op de opgegeven datum een vakantiestoperror122: LVK-punt was op de opgegeven datum niet meer actieferror123:
     * LVK-punt was op de opgegeven datum geslotenerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror267: Bij gekozen klachtonderwerp is nabezorging niet toegestaanerror751: Onterechte niet bezorgd klacht.
     * Uiterste tijdstip bezorging is niet verstrekenerror752: Verzoek tot nazending niet mogelijk. Verschijning is langer dan 3 dagen geledenerror753: Geen nazending mogelijk voor deze uitgaveerror754: Geen nazending mogelijk voor post of
     * ritbezorgingerror755: Klacht is reeds aangemelderror756: Onterechte niet nabezorgd klacht. Er is geen niet bezorgd klacht gevonden voor de verschijningerror757: Onterechte niet nabezorgd klacht. Bij de niet bezorgd klacht is niet om nazending
     * verzochterror758: Onterechte niet nabezorgd klacht. Termijn voor nabezorging is nog niet verstrekenerror759: Onterechte niet bezorgd klacht. Op verschijningsdatum gold voor het abonnement een verzendstop
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateBezorgKlachtRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateBezorgKlachtResponse|bool
     */
    public function createBezorgKlacht(\AbonnementApiV6\StructType\CreateBezorgKlachtRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createBezorgKlacht($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createBezKlachtRelUitgave
     * Meta information extracted from the WSDL
     * - documentation: Aanmaken van een bezorgklacht op basis van een opgegeven relatienummer en uitgavecodeerror1: Het abonnement is niet gevondenerror12: Er is geen abonnement opgegevenerror13: Er is geen klachtsoort opgegevenerror14: De klachtsoort is
     * niet bekenderror15: Het klachtonderwerp is niet bekenderror17: De default klachtstatus is niet gevondenerror18: Er is geen klachtsoort opgegevenerror25: Er is geen datum voor de klacht opgegevenerror77: Het klachtonderwerp is niet gekoppeld bij de
     * klachtsoorterror78: Op basis van de klachtdatum is geen editie gevondenerror79: De klachtsoort is niet actieferror80: Het klachtonderwerp is niet actieferror116: Deze klacht is niet aan een abonnement en niet aan een LVK-punt gekoppeld en kan daarom
     * niet ingevoerd wordenerror117: Uiterste bezorgtijd is nog niet verstreken. Klacht is niet geregistreerderror118: Het abonnement had op de opgegeven datum geen recht op een blad of was niet actieferror119: Het abonnement krijgt op de opgegeven datum
     * bonnen en geen bladerror120: Het abonnement werd op de opgegeven datum doorgestuurd naar een goed doel en ontving dus geen bladerror121: Het abonnement had op de opgegeven datum een vakantiestoperror122: LVK-punt was op de opgegeven datum niet meer
     * actieferror123: LVK-punt was op de opgegeven datum geslotenerror129: Datum heeft een verkeerd formaat of kan niet tot een bestaande datum worden herleiderror267: Bij gekozen klachtonderwerp is nabezorging niet toegestaanerror751: Onterechte niet
     * bezorgd klacht. Uiterste tijdstip bezorging is niet verstrekenerror752: Verzoek tot nazending niet mogelijk. Verschijning is langer dan 3 dagen geledenerror753: Geen nazending mogelijk voor deze uitgaveerror754: Geen nazending mogelijk voor post of
     * ritbezorgingerror755: Klacht is reeds aangemelderror756: Onterechte niet nabezorgd klacht. Er is geen niet bezorgd klacht gevonden voor de verschijningerror757: Onterechte niet nabezorgd klacht. Bij de niet bezorgd klacht is niet om nazending
     * verzochterror758: Onterechte niet nabezorgd klacht. Termijn voor nabezorging is nog niet verstrekenerror759: Onterechte niet bezorgd klacht. Op verschijningsdatum gold voor het abonnement een verzendstop
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateBezKlachtRelUitgaveRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateBezKlachtRelUitgaveResponse|bool
     */
    public function createBezKlachtRelUitgave(\AbonnementApiV6\StructType\CreateBezKlachtRelUitgaveRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createBezKlachtRelUitgave($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createKlantPersoon
     * Meta information extracted from the WSDL
     * - documentation: <u><b>Deprecated waarschuwing:</b> Deze operatie zal in een toekomstige webservice versie V6 worden verwijderd. <br/> Als alternatief wordt aangeraden om <b>RelatieApiV6.createPersoon</b> te gebruiken om de relatie aan te maken.
     * </br></u> <br/> Aanmaken van een nieuwe relatie van type persoon. Bij het aanmaken wordt op basis van de input gekeken of er al een persoon in de database staat die gelijk is. In dat geval wordt er geen nieuwe relatie aangemaakt maar wordt de
     * bestaande relatie gebruikt. De businessrules hiervoor zijn op te vragen bij de servicedesk van Socho_IT.error2: Het land is niet gevondenerror28: Bij een relatie is een naam verplichterror30: De adresgegevens zijn niet compleeterror31: Het e-mail
     * adres voldoet niet aan de eisenerror32: De adresgegevens ontbrekenerror38: Het telefoonnummer is niet geldigerror62: De titulatuur is niet bekenderror63: Het mobiele telefoonnummer is niet geldigerror66: De provincie is niet gevondenerror69: De
     * provincie is niet gekoppeld aan het landerror72: Voor een provincie is een land verplichterror81: Het adres is niet gevonden in de postcodetabelerror90: De opgegeven geboortedatum is niet geldigerror104: Het opgegeven geslacht is niet geldigerror215:
     * Het IBAN nummer is ongeldigerror216: De BIC code is ongeldigerror217: Bij automatische incasso of eenmalige incasso is een IBAN nummer verplichterror218: Het IBAN nummer dient samen met de BIC code opgegeven te wordenerror219: De opgegeven BIC code
     * hoort niet bij het opgegeven IBAN nummererror601: Er zijn meerdere kandidaten gevondenerror606: Er zijn afwijkende kandidaten gevonden
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AbonnementApiV6\StructType\CreateKlantPersoonRequest $request_parameters
     * @return \AbonnementApiV6\StructType\CreateKlantPersoonResponse|bool
     */
    public function createKlantPersoon(\AbonnementApiV6\StructType\CreateKlantPersoonRequest $request_parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->createKlantPersoon($request_parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \AbonnementApiV6\StructType\CreateAboAboNawResponse|\AbonnementApiV6\StructType\CreateAboAboNoResponse|\AbonnementApiV6\StructType\CreateAboDebNawAboNawResponse|\AbonnementApiV6\StructType\CreateAboDebNawAboNoResponse|\AbonnementApiV6\StructType\CreateAboDebNoAboNawResponse|\AbonnementApiV6\StructType\CreateAboDebNoAboNoResponse|\AbonnementApiV6\StructType\CreateBezKlachtRelUitgaveResponse|\AbonnementApiV6\StructType\CreateBezorgKlachtResponse|\AbonnementApiV6\StructType\CreateKlantPersoonResponse|\AbonnementApiV6\StructType\CreateVakantieRegelingResponse|\AbonnementApiV6\StructType\CreateVerhuizingResponse|\AbonnementApiV6\StructType\CreateVervolgAbonnementResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
