<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AboPakketAanvProdInfo StructType
 * Meta information extracted from the WSDL
 * - documentation: Lijst met onderliggende aanvullende producten onder dit pakket.
 * @subpackage Structs
 * @date 20240419 package
 */
class AboPakketAanvProdInfo extends AbstractStructBase
{
    /**
     * The aboPakketAanvProd
     * Meta information extracted from the WSDL
     * - documentation: Lijst met onderliggende aanvullende producten onder dit pakket.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\AboPakketAanvProd[]
     */
    public $aboPakketAanvProd;
    /**
     * Constructor method for AboPakketAanvProdInfo
     * @uses AboPakketAanvProdInfo::setAboPakketAanvProd()
     * @param \AbonnementApiV6\StructType\AboPakketAanvProd[] $aboPakketAanvProd
     */
    public function __construct(array $aboPakketAanvProd = array())
    {
        $this
            ->setAboPakketAanvProd($aboPakketAanvProd);
    }
    /**
     * Get aboPakketAanvProd value
     * @return \AbonnementApiV6\StructType\AboPakketAanvProd[]|null
     */
    public function getAboPakketAanvProd()
    {
        return $this->aboPakketAanvProd;
    }
    /**
     * This method is responsible for validating the values passed to the setAboPakketAanvProd method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAboPakketAanvProd method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAboPakketAanvProdForArrayConstraintsFromSetAboPakketAanvProd(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $aboPakketAanvProdInfoAboPakketAanvProdItem) {
            // validation for constraint: itemType
            if (!$aboPakketAanvProdInfoAboPakketAanvProdItem instanceof \AbonnementApiV6\StructType\AboPakketAanvProd) {
                $invalidValues[] = is_object($aboPakketAanvProdInfoAboPakketAanvProdItem) ? get_class($aboPakketAanvProdInfoAboPakketAanvProdItem) : sprintf('%s(%s)', gettype($aboPakketAanvProdInfoAboPakketAanvProdItem), var_export($aboPakketAanvProdInfoAboPakketAanvProdItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The aboPakketAanvProd property can only contain items of type \AbonnementApiV6\StructType\AboPakketAanvProd, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set aboPakketAanvProd value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\AboPakketAanvProd[] $aboPakketAanvProd
     * @return \AbonnementApiV6\StructType\AboPakketAanvProdInfo
     */
    public function setAboPakketAanvProd(array $aboPakketAanvProd = array())
    {
        // validation for constraint: array
        if ('' !== ($aboPakketAanvProdArrayErrorMessage = self::validateAboPakketAanvProdForArrayConstraintsFromSetAboPakketAanvProd($aboPakketAanvProd))) {
            throw new \InvalidArgumentException($aboPakketAanvProdArrayErrorMessage, __LINE__);
        }
        $this->aboPakketAanvProd = $aboPakketAanvProd;
        return $this;
    }
    /**
     * Add item to aboPakketAanvProd value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\AboPakketAanvProd $item
     * @return \AbonnementApiV6\StructType\AboPakketAanvProdInfo
     */
    public function addToAboPakketAanvProd(\AbonnementApiV6\StructType\AboPakketAanvProd $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\AboPakketAanvProd) {
            throw new \InvalidArgumentException(sprintf('The aboPakketAanvProd property can only contain items of type \AbonnementApiV6\StructType\AboPakketAanvProd, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->aboPakketAanvProd[] = $item;
        return $this;
    }
}
