<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AboPakketAboSoortInfo StructType
 * Meta information extracted from the WSDL
 * - documentation: Lijst met onderliggende abonnementsoorten onder dit pakket.
 * @subpackage Structs
 * @date 20240419 package
 */
class AboPakketAboSoortInfo extends AbstractStructBase
{
    /**
     * The aboPakketAboSoort
     * Meta information extracted from the WSDL
     * - documentation: Lijst met onderliggende abonnementsoorten onder dit pakket.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\AboPakketAboSoort[]
     */
    public $aboPakketAboSoort;
    /**
     * Constructor method for AboPakketAboSoortInfo
     * @uses AboPakketAboSoortInfo::setAboPakketAboSoort()
     * @param \AbonnementApiV6\StructType\AboPakketAboSoort[] $aboPakketAboSoort
     */
    public function __construct(array $aboPakketAboSoort = array())
    {
        $this
            ->setAboPakketAboSoort($aboPakketAboSoort);
    }
    /**
     * Get aboPakketAboSoort value
     * @return \AbonnementApiV6\StructType\AboPakketAboSoort[]|null
     */
    public function getAboPakketAboSoort()
    {
        return $this->aboPakketAboSoort;
    }
    /**
     * This method is responsible for validating the values passed to the setAboPakketAboSoort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAboPakketAboSoort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAboPakketAboSoortForArrayConstraintsFromSetAboPakketAboSoort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $aboPakketAboSoortInfoAboPakketAboSoortItem) {
            // validation for constraint: itemType
            if (!$aboPakketAboSoortInfoAboPakketAboSoortItem instanceof \AbonnementApiV6\StructType\AboPakketAboSoort) {
                $invalidValues[] = is_object($aboPakketAboSoortInfoAboPakketAboSoortItem) ? get_class($aboPakketAboSoortInfoAboPakketAboSoortItem) : sprintf('%s(%s)', gettype($aboPakketAboSoortInfoAboPakketAboSoortItem), var_export($aboPakketAboSoortInfoAboPakketAboSoortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The aboPakketAboSoort property can only contain items of type \AbonnementApiV6\StructType\AboPakketAboSoort, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set aboPakketAboSoort value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\AboPakketAboSoort[] $aboPakketAboSoort
     * @return \AbonnementApiV6\StructType\AboPakketAboSoortInfo
     */
    public function setAboPakketAboSoort(array $aboPakketAboSoort = array())
    {
        // validation for constraint: array
        if ('' !== ($aboPakketAboSoortArrayErrorMessage = self::validateAboPakketAboSoortForArrayConstraintsFromSetAboPakketAboSoort($aboPakketAboSoort))) {
            throw new \InvalidArgumentException($aboPakketAboSoortArrayErrorMessage, __LINE__);
        }
        $this->aboPakketAboSoort = $aboPakketAboSoort;
        return $this;
    }
    /**
     * Add item to aboPakketAboSoort value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\AboPakketAboSoort $item
     * @return \AbonnementApiV6\StructType\AboPakketAboSoortInfo
     */
    public function addToAboPakketAboSoort(\AbonnementApiV6\StructType\AboPakketAboSoort $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\AboPakketAboSoort) {
            throw new \InvalidArgumentException(sprintf('The aboPakketAboSoort property can only contain items of type \AbonnementApiV6\StructType\AboPakketAboSoort, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->aboPakketAboSoort[] = $item;
        return $this;
    }
}
