<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbonnementsoortInfo StructType
 * Meta information extracted from the WSDL
 * - documentation: Lijst met gevonden abonnementsoorten.
 * @subpackage Structs
 * @date 20240419 package
 */
class AbonnementsoortInfo extends AbstractStructBase
{
    /**
     * The abonnementsoort
     * Meta information extracted from the WSDL
     * - documentation: Lijst met gevonden abonnementsoorten.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\Abonnementsoort[]
     */
    public $abonnementsoort;
    /**
     * Constructor method for AbonnementsoortInfo
     * @uses AbonnementsoortInfo::setAbonnementsoort()
     * @param \AbonnementApiV6\StructType\Abonnementsoort[] $abonnementsoort
     */
    public function __construct(array $abonnementsoort = array())
    {
        $this
            ->setAbonnementsoort($abonnementsoort);
    }
    /**
     * Get abonnementsoort value
     * @return \AbonnementApiV6\StructType\Abonnementsoort[]|null
     */
    public function getAbonnementsoort()
    {
        return $this->abonnementsoort;
    }
    /**
     * This method is responsible for validating the values passed to the setAbonnementsoort method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAbonnementsoort method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAbonnementsoortForArrayConstraintsFromSetAbonnementsoort(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $abonnementsoortInfoAbonnementsoortItem) {
            // validation for constraint: itemType
            if (!$abonnementsoortInfoAbonnementsoortItem instanceof \AbonnementApiV6\StructType\Abonnementsoort) {
                $invalidValues[] = is_object($abonnementsoortInfoAbonnementsoortItem) ? get_class($abonnementsoortInfoAbonnementsoortItem) : sprintf('%s(%s)', gettype($abonnementsoortInfoAbonnementsoortItem), var_export($abonnementsoortInfoAbonnementsoortItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The abonnementsoort property can only contain items of type \AbonnementApiV6\StructType\Abonnementsoort, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set abonnementsoort value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\Abonnementsoort[] $abonnementsoort
     * @return \AbonnementApiV6\StructType\AbonnementsoortInfo
     */
    public function setAbonnementsoort(array $abonnementsoort = array())
    {
        // validation for constraint: array
        if ('' !== ($abonnementsoortArrayErrorMessage = self::validateAbonnementsoortForArrayConstraintsFromSetAbonnementsoort($abonnementsoort))) {
            throw new \InvalidArgumentException($abonnementsoortArrayErrorMessage, __LINE__);
        }
        $this->abonnementsoort = $abonnementsoort;
        return $this;
    }
    /**
     * Add item to abonnementsoort value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\Abonnementsoort $item
     * @return \AbonnementApiV6\StructType\AbonnementsoortInfo
     */
    public function addToAbonnementsoort(\AbonnementApiV6\StructType\Abonnementsoort $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\Abonnementsoort) {
            throw new \InvalidArgumentException(sprintf('The abonnementsoort property can only contain items of type \AbonnementApiV6\StructType\Abonnementsoort, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->abonnementsoort[] = $item;
        return $this;
    }
}
