<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bestaatActiefAbonnementResponse StructType
 * @subpackage Structs
 * @date 20240419 package
 */
class BestaatActiefAbonnementResponse extends AbstractStructBase
{
    /**
     * The requestTag
     * Meta information extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The actiefAbonnementBestaat
     * Meta information extracted from the WSDL
     * - documentation: Er is een actief abonnement gevonden, ja (true) of nee (false).
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $actiefAbonnementBestaat;
    /**
     * Constructor method for bestaatActiefAbonnementResponse
     * @uses BestaatActiefAbonnementResponse::setRequestTag()
     * @uses BestaatActiefAbonnementResponse::setActiefAbonnementBestaat()
     * @param string $requestTag
     * @param bool $actiefAbonnementBestaat
     */
    public function __construct($requestTag = null, $actiefAbonnementBestaat = null)
    {
        $this
            ->setRequestTag($requestTag)
            ->setActiefAbonnementBestaat($actiefAbonnementBestaat);
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \AbonnementApiV6\StructType\BestaatActiefAbonnementResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get actiefAbonnementBestaat value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getActiefAbonnementBestaat()
    {
        return isset($this->actiefAbonnementBestaat) ? $this->actiefAbonnementBestaat : null;
    }
    /**
     * Set actiefAbonnementBestaat value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $actiefAbonnementBestaat
     * @return \AbonnementApiV6\StructType\BestaatActiefAbonnementResponse
     */
    public function setActiefAbonnementBestaat($actiefAbonnementBestaat = null)
    {
        // validation for constraint: boolean
        if (!is_null($actiefAbonnementBestaat) && !is_bool($actiefAbonnementBestaat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($actiefAbonnementBestaat, true), gettype($actiefAbonnementBestaat)), __LINE__);
        }
        if (is_null($actiefAbonnementBestaat) || (is_array($actiefAbonnementBestaat) && empty($actiefAbonnementBestaat))) {
            unset($this->actiefAbonnementBestaat);
        } else {
            $this->actiefAbonnementBestaat = $actiefAbonnementBestaat;
        }
        return $this;
    }
}
