<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createVakantieRegelingRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Maakt een vakantieregeling aan voor een abonnement van het type type 'onderbreking met verlenging' ,'vakantiebonnen', 'goed doel' of 'doorsturen'
 * @subpackage Structs
 * @date 20240419 package
 */
class CreateVakantieRegelingRequest extends AbstractStructBase
{
    /**
     * The aboNo
     * Meta information extracted from the WSDL
     * - documentation: Nummer van het abonnement waarvoor de regeling geldt.
     * - base: xsd:integer
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - totalDigits: 15
     * @var int
     */
    public $aboNo;
    /**
     * The vakantieDatumVan
     * Meta information extracted from the WSDL
     * - documentation: Regeling geldig vanaf. Moet in toekomst liggen.
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $vakantieDatumVan;
    /**
     * The vakantieDatumTm
     * Meta information extracted from the WSDL
     * - documentation: Regeling geldig tm. Moet na ingangsdatum liggen.
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $vakantieDatumTm;
    /**
     * The requestTag
     * Meta information extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The persoonsObjectOntvanger
     * Meta information extracted from the WSDL
     * - documentation: Persoonsgegevens van de relatie die de tijdelijke ontvanger is. Verplicht bij vakantieRegelingType 5 (doorsturen).
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AbonnementApiV6\StructType\PersoonsObject
     */
    public $persoonsObjectOntvanger;
    /**
     * The adresObjectVakantie
     * Meta information extracted from the WSDL
     * - documentation: Adresgegevens van het tijdelijke adres, of het adres van de tijdelijke ontvanger. Verplicht bij vakantieRegelingType 4 (vakantieadres) en 5 (doorsturen).
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AbonnementApiV6\StructType\AdresObject
     */
    public $adresObjectVakantie;
    /**
     * The tijdelijkeAfdelingsNaam
     * Meta information extracted from the WSDL
     * - documentation: Afdelings naam bij het tijdelijke adres. Toegestaan bij vakantieRegelingType 4 (vakantieadres).
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tijdelijkeAfdelingsNaam;
    /**
     * The vakantieRegelingType
     * Meta information extracted from the WSDL
     * - documentation: [1,2,3,4,5,6] Soort vakantieregeling. 1 = Onderbreking + verlengen, 2 = Goed doel, 3 = Vakantie bonnen, 4 = Vakantieadres, 5=Doorsturen naar vriend of familie, 6 = Onderbreken zonder verlenging en restitutieregeling.
     * - base: xsd:decimal
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - totalDigits: 38
     * @var float
     */
    public $vakantieRegelingType;
    /**
     * The forceerNieuweKlant
     * Meta information extracted from the WSDL
     * - documentation: Aanmaken nieuwe klant forceren, dus niet controleren of de klant al bestaat. Default false dus wel controleren en eventueel bestaande klant gebruiken.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $forceerNieuweKlant;
    /**
     * The canCreate
     * Meta information extracted from the WSDL
     * - documentation: Indicatie of operatie in de testmodus wordt aangeroepen (er wordt dus geen vakantieregeling aangemaakt) false (Default) = aanmaken, true = testmodus niet aanmaken.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $canCreate;
    /**
     * Constructor method for createVakantieRegelingRequest
     * @uses CreateVakantieRegelingRequest::setAboNo()
     * @uses CreateVakantieRegelingRequest::setVakantieDatumVan()
     * @uses CreateVakantieRegelingRequest::setVakantieDatumTm()
     * @uses CreateVakantieRegelingRequest::setRequestTag()
     * @uses CreateVakantieRegelingRequest::setPersoonsObjectOntvanger()
     * @uses CreateVakantieRegelingRequest::setAdresObjectVakantie()
     * @uses CreateVakantieRegelingRequest::setTijdelijkeAfdelingsNaam()
     * @uses CreateVakantieRegelingRequest::setVakantieRegelingType()
     * @uses CreateVakantieRegelingRequest::setForceerNieuweKlant()
     * @uses CreateVakantieRegelingRequest::setCanCreate()
     * @param int $aboNo
     * @param string $vakantieDatumVan
     * @param string $vakantieDatumTm
     * @param string $requestTag
     * @param \AbonnementApiV6\StructType\PersoonsObject $persoonsObjectOntvanger
     * @param \AbonnementApiV6\StructType\AdresObject $adresObjectVakantie
     * @param string $tijdelijkeAfdelingsNaam
     * @param float $vakantieRegelingType
     * @param bool $forceerNieuweKlant
     * @param bool $canCreate
     */
    public function __construct($aboNo = null, $vakantieDatumVan = null, $vakantieDatumTm = null, $requestTag = null, \AbonnementApiV6\StructType\PersoonsObject $persoonsObjectOntvanger = null, \AbonnementApiV6\StructType\AdresObject $adresObjectVakantie = null, $tijdelijkeAfdelingsNaam = null, $vakantieRegelingType = null, $forceerNieuweKlant = null, $canCreate = null)
    {
        $this
            ->setAboNo($aboNo)
            ->setVakantieDatumVan($vakantieDatumVan)
            ->setVakantieDatumTm($vakantieDatumTm)
            ->setRequestTag($requestTag)
            ->setPersoonsObjectOntvanger($persoonsObjectOntvanger)
            ->setAdresObjectVakantie($adresObjectVakantie)
            ->setTijdelijkeAfdelingsNaam($tijdelijkeAfdelingsNaam)
            ->setVakantieRegelingType($vakantieRegelingType)
            ->setForceerNieuweKlant($forceerNieuweKlant)
            ->setCanCreate($canCreate);
    }
    /**
     * Get aboNo value
     * @return int
     */
    public function getAboNo()
    {
        return $this->aboNo;
    }
    /**
     * Set aboNo value
     * @param int $aboNo
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setAboNo($aboNo = null)
    {
        // validation for constraint: int
        if (!is_null($aboNo) && !(is_int($aboNo) || ctype_digit($aboNo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($aboNo, true), gettype($aboNo)), __LINE__);
        }
        // validation for constraint: totalDigits(15)
        if (!is_null($aboNo) && mb_strlen(preg_replace('/(\D)/', '', $aboNo)) > 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 15 digits, "%d" given', var_export($aboNo, true), mb_strlen(preg_replace('/(\D)/', '', $aboNo))), __LINE__);
        }
        $this->aboNo = $aboNo;
        return $this;
    }
    /**
     * Get vakantieDatumVan value
     * @return string
     */
    public function getVakantieDatumVan()
    {
        return $this->vakantieDatumVan;
    }
    /**
     * Set vakantieDatumVan value
     * @param string $vakantieDatumVan
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setVakantieDatumVan($vakantieDatumVan = null)
    {
        // validation for constraint: string
        if (!is_null($vakantieDatumVan) && !is_string($vakantieDatumVan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vakantieDatumVan, true), gettype($vakantieDatumVan)), __LINE__);
        }
        $this->vakantieDatumVan = $vakantieDatumVan;
        return $this;
    }
    /**
     * Get vakantieDatumTm value
     * @return string
     */
    public function getVakantieDatumTm()
    {
        return $this->vakantieDatumTm;
    }
    /**
     * Set vakantieDatumTm value
     * @param string $vakantieDatumTm
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setVakantieDatumTm($vakantieDatumTm = null)
    {
        // validation for constraint: string
        if (!is_null($vakantieDatumTm) && !is_string($vakantieDatumTm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vakantieDatumTm, true), gettype($vakantieDatumTm)), __LINE__);
        }
        $this->vakantieDatumTm = $vakantieDatumTm;
        return $this;
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get persoonsObjectOntvanger value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AbonnementApiV6\StructType\PersoonsObject|null
     */
    public function getPersoonsObjectOntvanger()
    {
        return isset($this->persoonsObjectOntvanger) ? $this->persoonsObjectOntvanger : null;
    }
    /**
     * Set persoonsObjectOntvanger value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AbonnementApiV6\StructType\PersoonsObject $persoonsObjectOntvanger
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setPersoonsObjectOntvanger(\AbonnementApiV6\StructType\PersoonsObject $persoonsObjectOntvanger = null)
    {
        if (is_null($persoonsObjectOntvanger) || (is_array($persoonsObjectOntvanger) && empty($persoonsObjectOntvanger))) {
            unset($this->persoonsObjectOntvanger);
        } else {
            $this->persoonsObjectOntvanger = $persoonsObjectOntvanger;
        }
        return $this;
    }
    /**
     * Get adresObjectVakantie value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AbonnementApiV6\StructType\AdresObject|null
     */
    public function getAdresObjectVakantie()
    {
        return isset($this->adresObjectVakantie) ? $this->adresObjectVakantie : null;
    }
    /**
     * Set adresObjectVakantie value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AbonnementApiV6\StructType\AdresObject $adresObjectVakantie
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setAdresObjectVakantie(\AbonnementApiV6\StructType\AdresObject $adresObjectVakantie = null)
    {
        if (is_null($adresObjectVakantie) || (is_array($adresObjectVakantie) && empty($adresObjectVakantie))) {
            unset($this->adresObjectVakantie);
        } else {
            $this->adresObjectVakantie = $adresObjectVakantie;
        }
        return $this;
    }
    /**
     * Get tijdelijkeAfdelingsNaam value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTijdelijkeAfdelingsNaam()
    {
        return isset($this->tijdelijkeAfdelingsNaam) ? $this->tijdelijkeAfdelingsNaam : null;
    }
    /**
     * Set tijdelijkeAfdelingsNaam value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tijdelijkeAfdelingsNaam
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setTijdelijkeAfdelingsNaam($tijdelijkeAfdelingsNaam = null)
    {
        // validation for constraint: string
        if (!is_null($tijdelijkeAfdelingsNaam) && !is_string($tijdelijkeAfdelingsNaam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tijdelijkeAfdelingsNaam, true), gettype($tijdelijkeAfdelingsNaam)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($tijdelijkeAfdelingsNaam) && mb_strlen($tijdelijkeAfdelingsNaam) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($tijdelijkeAfdelingsNaam)), __LINE__);
        }
        if (is_null($tijdelijkeAfdelingsNaam) || (is_array($tijdelijkeAfdelingsNaam) && empty($tijdelijkeAfdelingsNaam))) {
            unset($this->tijdelijkeAfdelingsNaam);
        } else {
            $this->tijdelijkeAfdelingsNaam = $tijdelijkeAfdelingsNaam;
        }
        return $this;
    }
    /**
     * Get vakantieRegelingType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getVakantieRegelingType()
    {
        return isset($this->vakantieRegelingType) ? $this->vakantieRegelingType : null;
    }
    /**
     * Set vakantieRegelingType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $vakantieRegelingType
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setVakantieRegelingType($vakantieRegelingType = null)
    {
        // validation for constraint: float
        if (!is_null($vakantieRegelingType) && !(is_float($vakantieRegelingType) || is_numeric($vakantieRegelingType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($vakantieRegelingType, true), gettype($vakantieRegelingType)), __LINE__);
        }
        // validation for constraint: totalDigits(38)
        if (!is_null($vakantieRegelingType) && mb_strlen(preg_replace('/(\D)/', '', $vakantieRegelingType)) > 38) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 38 digits, "%d" given', var_export($vakantieRegelingType, true), mb_strlen(preg_replace('/(\D)/', '', $vakantieRegelingType))), __LINE__);
        }
        if (is_null($vakantieRegelingType) || (is_array($vakantieRegelingType) && empty($vakantieRegelingType))) {
            unset($this->vakantieRegelingType);
        } else {
            $this->vakantieRegelingType = $vakantieRegelingType;
        }
        return $this;
    }
    /**
     * Get forceerNieuweKlant value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getForceerNieuweKlant()
    {
        return isset($this->forceerNieuweKlant) ? $this->forceerNieuweKlant : null;
    }
    /**
     * Set forceerNieuweKlant value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $forceerNieuweKlant
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setForceerNieuweKlant($forceerNieuweKlant = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceerNieuweKlant) && !is_bool($forceerNieuweKlant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($forceerNieuweKlant, true), gettype($forceerNieuweKlant)), __LINE__);
        }
        if (is_null($forceerNieuweKlant) || (is_array($forceerNieuweKlant) && empty($forceerNieuweKlant))) {
            unset($this->forceerNieuweKlant);
        } else {
            $this->forceerNieuweKlant = $forceerNieuweKlant;
        }
        return $this;
    }
    /**
     * Get canCreate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getCanCreate()
    {
        return isset($this->canCreate) ? $this->canCreate : null;
    }
    /**
     * Set canCreate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $canCreate
     * @return \AbonnementApiV6\StructType\CreateVakantieRegelingRequest
     */
    public function setCanCreate($canCreate = null)
    {
        // validation for constraint: boolean
        if (!is_null($canCreate) && !is_bool($canCreate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($canCreate, true), gettype($canCreate)), __LINE__);
        }
        if (is_null($canCreate) || (is_array($canCreate) && empty($canCreate))) {
            unset($this->canCreate);
        } else {
            $this->canCreate = $canCreate;
        }
        return $this;
    }
}
