<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getEditiesResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: error2: Het abonnement is niet gevonden op basis van de opgegeven aboNo
 * @subpackage Structs
 * @date 20240419 package
 */
class GetEditiesResponse extends AbstractStructBase
{
    /**
     * The requestTag
     * Meta information extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The edities
     * Meta information extracted from the WSDL
     * - documentation: Lijst van gevonden edities
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \AbonnementApiV6\StructType\EditieInfo
     */
    public $edities;
    /**
     * Constructor method for getEditiesResponse
     * @uses GetEditiesResponse::setRequestTag()
     * @uses GetEditiesResponse::setEdities()
     * @param string $requestTag
     * @param \AbonnementApiV6\StructType\EditieInfo $edities
     */
    public function __construct($requestTag = null, \AbonnementApiV6\StructType\EditieInfo $edities = null)
    {
        $this
            ->setRequestTag($requestTag)
            ->setEdities($edities);
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \AbonnementApiV6\StructType\GetEditiesResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get edities value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \AbonnementApiV6\StructType\EditieInfo|null
     */
    public function getEdities()
    {
        return isset($this->edities) ? $this->edities : null;
    }
    /**
     * Set edities value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \AbonnementApiV6\StructType\EditieInfo $edities
     * @return \AbonnementApiV6\StructType\GetEditiesResponse
     */
    public function setEdities(\AbonnementApiV6\StructType\EditieInfo $edities = null)
    {
        if (is_null($edities) || (is_array($edities) && empty($edities))) {
            unset($this->edities);
        } else {
            $this->edities = $edities;
        }
        return $this;
    }
}
