<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getRelatieAbosoortPrijsRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Geeft de prijs terug van een abonnementsoort die voor een relatie geldt
 * @subpackage Structs
 * @date 20240419 package
 */
class GetRelatieAbosoortPrijsRequest extends AbstractStructBase
{
    /**
     * The abonnementsoortCode
     * Meta information extracted from the WSDL
     * - documentation: Code van het abonnementsoort.
     * - base: xsd:string
     * - maxLength: 30
     * - maxOccurs: 1
     * - minLength: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $abonnementsoortCode;
    /**
     * The relatienummerAbonnee
     * Meta information extracted from the WSDL
     * - documentation: Relatienummer van de abonnee. Wordt gebruikt om te bepalen wat de prijs van de abonnementsoort is in het land van de abonnee.
     * - base: xsd:integer
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - totalDigits: 15
     * @var int
     */
    public $relatienummerAbonnee;
    /**
     * The requestTag
     * Meta information extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * The relatienummerDebiteur
     * Meta information extracted from the WSDL
     * - documentation: Relatienummer van de debiteur. Wordt gebruikt om te bepalen welk BTW percentage er van toepassing is (indien gebruik wordt gemaakt van geopteerde BTW). Indien leeg, wordt de abonneerelatie gebruikt.
     * - base: xsd:integer
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - totalDigits: 15
     * @var int
     */
    public $relatienummerDebiteur;
    /**
     * The aantal
     * Meta information extracted from the WSDL
     * - documentation: Het aantal exemplaren dat af wordt genomen.
     * - base: xsd:decimal
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - totalDigits: 38
     * @var float
     */
    public $aantal;
    /**
     * Constructor method for getRelatieAbosoortPrijsRequest
     * @uses GetRelatieAbosoortPrijsRequest::setAbonnementsoortCode()
     * @uses GetRelatieAbosoortPrijsRequest::setRelatienummerAbonnee()
     * @uses GetRelatieAbosoortPrijsRequest::setRequestTag()
     * @uses GetRelatieAbosoortPrijsRequest::setRelatienummerDebiteur()
     * @uses GetRelatieAbosoortPrijsRequest::setAantal()
     * @param string $abonnementsoortCode
     * @param int $relatienummerAbonnee
     * @param string $requestTag
     * @param int $relatienummerDebiteur
     * @param float $aantal
     */
    public function __construct($abonnementsoortCode = null, $relatienummerAbonnee = null, $requestTag = null, $relatienummerDebiteur = null, $aantal = null)
    {
        $this
            ->setAbonnementsoortCode($abonnementsoortCode)
            ->setRelatienummerAbonnee($relatienummerAbonnee)
            ->setRequestTag($requestTag)
            ->setRelatienummerDebiteur($relatienummerDebiteur)
            ->setAantal($aantal);
    }
    /**
     * Get abonnementsoortCode value
     * @return string
     */
    public function getAbonnementsoortCode()
    {
        return $this->abonnementsoortCode;
    }
    /**
     * Set abonnementsoortCode value
     * @param string $abonnementsoortCode
     * @return \AbonnementApiV6\StructType\GetRelatieAbosoortPrijsRequest
     */
    public function setAbonnementsoortCode($abonnementsoortCode = null)
    {
        // validation for constraint: string
        if (!is_null($abonnementsoortCode) && !is_string($abonnementsoortCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($abonnementsoortCode, true), gettype($abonnementsoortCode)), __LINE__);
        }
        // validation for constraint: maxLength(30)
        if (!is_null($abonnementsoortCode) && mb_strlen($abonnementsoortCode) > 30) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 30', mb_strlen($abonnementsoortCode)), __LINE__);
        }
        // validation for constraint: minLength(1)
        if (!is_null($abonnementsoortCode) && mb_strlen($abonnementsoortCode) < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be greater than or equal to 1', mb_strlen($abonnementsoortCode)), __LINE__);
        }
        $this->abonnementsoortCode = $abonnementsoortCode;
        return $this;
    }
    /**
     * Get relatienummerAbonnee value
     * @return int
     */
    public function getRelatienummerAbonnee()
    {
        return $this->relatienummerAbonnee;
    }
    /**
     * Set relatienummerAbonnee value
     * @param int $relatienummerAbonnee
     * @return \AbonnementApiV6\StructType\GetRelatieAbosoortPrijsRequest
     */
    public function setRelatienummerAbonnee($relatienummerAbonnee = null)
    {
        // validation for constraint: int
        if (!is_null($relatienummerAbonnee) && !(is_int($relatienummerAbonnee) || ctype_digit($relatienummerAbonnee))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($relatienummerAbonnee, true), gettype($relatienummerAbonnee)), __LINE__);
        }
        // validation for constraint: totalDigits(15)
        if (!is_null($relatienummerAbonnee) && mb_strlen(preg_replace('/(\D)/', '', $relatienummerAbonnee)) > 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 15 digits, "%d" given', var_export($relatienummerAbonnee, true), mb_strlen(preg_replace('/(\D)/', '', $relatienummerAbonnee))), __LINE__);
        }
        $this->relatienummerAbonnee = $relatienummerAbonnee;
        return $this;
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \AbonnementApiV6\StructType\GetRelatieAbosoortPrijsRequest
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get relatienummerDebiteur value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getRelatienummerDebiteur()
    {
        return isset($this->relatienummerDebiteur) ? $this->relatienummerDebiteur : null;
    }
    /**
     * Set relatienummerDebiteur value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $relatienummerDebiteur
     * @return \AbonnementApiV6\StructType\GetRelatieAbosoortPrijsRequest
     */
    public function setRelatienummerDebiteur($relatienummerDebiteur = null)
    {
        // validation for constraint: int
        if (!is_null($relatienummerDebiteur) && !(is_int($relatienummerDebiteur) || ctype_digit($relatienummerDebiteur))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($relatienummerDebiteur, true), gettype($relatienummerDebiteur)), __LINE__);
        }
        // validation for constraint: totalDigits(15)
        if (!is_null($relatienummerDebiteur) && mb_strlen(preg_replace('/(\D)/', '', $relatienummerDebiteur)) > 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 15 digits, "%d" given', var_export($relatienummerDebiteur, true), mb_strlen(preg_replace('/(\D)/', '', $relatienummerDebiteur))), __LINE__);
        }
        if (is_null($relatienummerDebiteur) || (is_array($relatienummerDebiteur) && empty($relatienummerDebiteur))) {
            unset($this->relatienummerDebiteur);
        } else {
            $this->relatienummerDebiteur = $relatienummerDebiteur;
        }
        return $this;
    }
    /**
     * Get aantal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getAantal()
    {
        return isset($this->aantal) ? $this->aantal : null;
    }
    /**
     * Set aantal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $aantal
     * @return \AbonnementApiV6\StructType\GetRelatieAbosoortPrijsRequest
     */
    public function setAantal($aantal = null)
    {
        // validation for constraint: float
        if (!is_null($aantal) && !(is_float($aantal) || is_numeric($aantal))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($aantal, true), gettype($aantal)), __LINE__);
        }
        // validation for constraint: totalDigits(38)
        if (!is_null($aantal) && mb_strlen(preg_replace('/(\D)/', '', $aantal)) > 38) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 38 digits, "%d" given', var_export($aantal, true), mb_strlen(preg_replace('/(\D)/', '', $aantal))), __LINE__);
        }
        if (is_null($aantal) || (is_array($aantal) && empty($aantal))) {
            unset($this->aantal);
        } else {
            $this->aantal = $aantal;
        }
        return $this;
    }
}
