<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getSmartcodeByAboNoRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Geeft de smartcode van een abonnement nummer terug.
 * @subpackage Structs
 * @date 20240419 package
 */
class GetSmartcodeByAboNoRequest extends AbstractStructBase
{
    /**
     * The abonnementNummer
     * Meta information extracted from the WSDL
     * - documentation: Het abonnement nummer waarvan de smartcode van moet worden opgevraagd.
     * - base: xsd:integer
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - totalDigits: 15
     * @var int
     */
    public $abonnementNummer;
    /**
     * The requestTag
     * Meta information extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - base: xsd:string
     * - maxLength: 4000
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requestTag;
    /**
     * Constructor method for getSmartcodeByAboNoRequest
     * @uses GetSmartcodeByAboNoRequest::setAbonnementNummer()
     * @uses GetSmartcodeByAboNoRequest::setRequestTag()
     * @param int $abonnementNummer
     * @param string $requestTag
     */
    public function __construct($abonnementNummer = null, $requestTag = null)
    {
        $this
            ->setAbonnementNummer($abonnementNummer)
            ->setRequestTag($requestTag);
    }
    /**
     * Get abonnementNummer value
     * @return int
     */
    public function getAbonnementNummer()
    {
        return $this->abonnementNummer;
    }
    /**
     * Set abonnementNummer value
     * @param int $abonnementNummer
     * @return \AbonnementApiV6\StructType\GetSmartcodeByAboNoRequest
     */
    public function setAbonnementNummer($abonnementNummer = null)
    {
        // validation for constraint: int
        if (!is_null($abonnementNummer) && !(is_int($abonnementNummer) || ctype_digit($abonnementNummer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($abonnementNummer, true), gettype($abonnementNummer)), __LINE__);
        }
        // validation for constraint: totalDigits(15)
        if (!is_null($abonnementNummer) && mb_strlen(preg_replace('/(\D)/', '', $abonnementNummer)) > 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must use at most 15 digits, "%d" given', var_export($abonnementNummer, true), mb_strlen(preg_replace('/(\D)/', '', $abonnementNummer))), __LINE__);
        }
        $this->abonnementNummer = $abonnementNummer;
        return $this;
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \AbonnementApiV6\StructType\GetSmartcodeByAboNoRequest
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestTag, true), gettype($requestTag)), __LINE__);
        }
        // validation for constraint: maxLength(4000)
        if (!is_null($requestTag) && mb_strlen($requestTag) > 4000) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 4000', mb_strlen($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
}
