<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropositiePremiumsTab StructType
 * Meta information extracted from the WSDL
 * - documentation: Een lijst met de gevonden premiums bij de propositie
 * @subpackage Structs
 * @date 20240419 package
 */
class PropositiePremiumsTab extends AbstractStructBase
{
    /**
     * The propositiePremium
     * Meta information extracted from the WSDL
     * - documentation: Een lijst met de gevonden premiums bij de propositie.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\PropositiePremiums[]
     */
    public $propositiePremium;
    /**
     * Constructor method for PropositiePremiumsTab
     * @uses PropositiePremiumsTab::setPropositiePremium()
     * @param \AbonnementApiV6\StructType\PropositiePremiums[] $propositiePremium
     */
    public function __construct(array $propositiePremium = array())
    {
        $this
            ->setPropositiePremium($propositiePremium);
    }
    /**
     * Get propositiePremium value
     * @return \AbonnementApiV6\StructType\PropositiePremiums[]|null
     */
    public function getPropositiePremium()
    {
        return $this->propositiePremium;
    }
    /**
     * This method is responsible for validating the values passed to the setPropositiePremium method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPropositiePremium method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePropositiePremiumForArrayConstraintsFromSetPropositiePremium(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $propositiePremiumsTabPropositiePremiumItem) {
            // validation for constraint: itemType
            if (!$propositiePremiumsTabPropositiePremiumItem instanceof \AbonnementApiV6\StructType\PropositiePremiums) {
                $invalidValues[] = is_object($propositiePremiumsTabPropositiePremiumItem) ? get_class($propositiePremiumsTabPropositiePremiumItem) : sprintf('%s(%s)', gettype($propositiePremiumsTabPropositiePremiumItem), var_export($propositiePremiumsTabPropositiePremiumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The propositiePremium property can only contain items of type \AbonnementApiV6\StructType\PropositiePremiums, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set propositiePremium value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\PropositiePremiums[] $propositiePremium
     * @return \AbonnementApiV6\StructType\PropositiePremiumsTab
     */
    public function setPropositiePremium(array $propositiePremium = array())
    {
        // validation for constraint: array
        if ('' !== ($propositiePremiumArrayErrorMessage = self::validatePropositiePremiumForArrayConstraintsFromSetPropositiePremium($propositiePremium))) {
            throw new \InvalidArgumentException($propositiePremiumArrayErrorMessage, __LINE__);
        }
        $this->propositiePremium = $propositiePremium;
        return $this;
    }
    /**
     * Add item to propositiePremium value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\PropositiePremiums $item
     * @return \AbonnementApiV6\StructType\PropositiePremiumsTab
     */
    public function addToPropositiePremium(\AbonnementApiV6\StructType\PropositiePremiums $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\PropositiePremiums) {
            throw new \InvalidArgumentException(sprintf('The propositiePremium property can only contain items of type \AbonnementApiV6\StructType\PropositiePremiums, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->propositiePremium[] = $item;
        return $this;
    }
}
