<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropositieTab StructType
 * Meta information extracted from the WSDL
 * - documentation: Lijst met proposities.
 * @subpackage Structs
 * @date 20240419 package
 */
class PropositieTab extends AbstractStructBase
{
    /**
     * The propositie
     * Meta information extracted from the WSDL
     * - documentation: Lijst met proposities.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\PropositieObject[]
     */
    public $propositie;
    /**
     * Constructor method for PropositieTab
     * @uses PropositieTab::setPropositie()
     * @param \AbonnementApiV6\StructType\PropositieObject[] $propositie
     */
    public function __construct(array $propositie = array())
    {
        $this
            ->setPropositie($propositie);
    }
    /**
     * Get propositie value
     * @return \AbonnementApiV6\StructType\PropositieObject[]|null
     */
    public function getPropositie()
    {
        return $this->propositie;
    }
    /**
     * This method is responsible for validating the values passed to the setPropositie method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPropositie method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePropositieForArrayConstraintsFromSetPropositie(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $propositieTabPropositieItem) {
            // validation for constraint: itemType
            if (!$propositieTabPropositieItem instanceof \AbonnementApiV6\StructType\PropositieObject) {
                $invalidValues[] = is_object($propositieTabPropositieItem) ? get_class($propositieTabPropositieItem) : sprintf('%s(%s)', gettype($propositieTabPropositieItem), var_export($propositieTabPropositieItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The propositie property can only contain items of type \AbonnementApiV6\StructType\PropositieObject, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set propositie value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\PropositieObject[] $propositie
     * @return \AbonnementApiV6\StructType\PropositieTab
     */
    public function setPropositie(array $propositie = array())
    {
        // validation for constraint: array
        if ('' !== ($propositieArrayErrorMessage = self::validatePropositieForArrayConstraintsFromSetPropositie($propositie))) {
            throw new \InvalidArgumentException($propositieArrayErrorMessage, __LINE__);
        }
        $this->propositie = $propositie;
        return $this;
    }
    /**
     * Add item to propositie value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\PropositieObject $item
     * @return \AbonnementApiV6\StructType\PropositieTab
     */
    public function addToPropositie(\AbonnementApiV6\StructType\PropositieObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\PropositieObject) {
            throw new \InvalidArgumentException(sprintf('The propositie property can only contain items of type \AbonnementApiV6\StructType\PropositieObject, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->propositie[] = $item;
        return $this;
    }
}
