<?php

namespace AbonnementApiV6\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VerschInfoTab StructType
 * Meta information extracted from the WSDL
 * - documentation: Lijst met verschijningen.
 * @subpackage Structs
 * @date 20240419 package
 */
class VerschInfoTab extends AbstractStructBase
{
    /**
     * The verschInfo
     * Meta information extracted from the WSDL
     * - documentation: Lijst met verschijningen.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \AbonnementApiV6\StructType\VerschInfo[]
     */
    public $verschInfo;
    /**
     * Constructor method for VerschInfoTab
     * @uses VerschInfoTab::setVerschInfo()
     * @param \AbonnementApiV6\StructType\VerschInfo[] $verschInfo
     */
    public function __construct(array $verschInfo = array())
    {
        $this
            ->setVerschInfo($verschInfo);
    }
    /**
     * Get verschInfo value
     * @return \AbonnementApiV6\StructType\VerschInfo[]|null
     */
    public function getVerschInfo()
    {
        return $this->verschInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setVerschInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVerschInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVerschInfoForArrayConstraintsFromSetVerschInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $verschInfoTabVerschInfoItem) {
            // validation for constraint: itemType
            if (!$verschInfoTabVerschInfoItem instanceof \AbonnementApiV6\StructType\VerschInfo) {
                $invalidValues[] = is_object($verschInfoTabVerschInfoItem) ? get_class($verschInfoTabVerschInfoItem) : sprintf('%s(%s)', gettype($verschInfoTabVerschInfoItem), var_export($verschInfoTabVerschInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The verschInfo property can only contain items of type \AbonnementApiV6\StructType\VerschInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set verschInfo value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\VerschInfo[] $verschInfo
     * @return \AbonnementApiV6\StructType\VerschInfoTab
     */
    public function setVerschInfo(array $verschInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($verschInfoArrayErrorMessage = self::validateVerschInfoForArrayConstraintsFromSetVerschInfo($verschInfo))) {
            throw new \InvalidArgumentException($verschInfoArrayErrorMessage, __LINE__);
        }
        $this->verschInfo = $verschInfo;
        return $this;
    }
    /**
     * Add item to verschInfo value
     * @throws \InvalidArgumentException
     * @param \AbonnementApiV6\StructType\VerschInfo $item
     * @return \AbonnementApiV6\StructType\VerschInfoTab
     */
    public function addToVerschInfo(\AbonnementApiV6\StructType\VerschInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AbonnementApiV6\StructType\VerschInfo) {
            throw new \InvalidArgumentException(sprintf('The verschInfo property can only contain items of type \AbonnementApiV6\StructType\VerschInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->verschInfo[] = $item;
        return $this;
    }
}
